<?php

/*
Plugin Name: Kontera ContentLink
Plugin URI: http://www.kontera.com
Description: This plugin will add your Kontera JavaScript code to your blog
Version: 1.3 
Author: Kontera
Author URI: http://www.kontera.com

////////////////////////////////
Kontera Plug-In License Agreement
////////////////////////////////

This Kontera Plug-In License Agreement (“Agreement’) is a legal agreement between you (“Publisher”) and Kontera
Technologies, Inc. (“Kontera”). YOU MUST READ AND AGREE TO THE TERMS OF THIS AGREEMENT
BEFORE YOU CAN IMPLEMENT AND BEGIN USING THE KONTERA PLUG-IN. BY USING, REPRODUCING
OR MODIFYING THE KONTERA PLUG-IN IN ANY WAY, YOU HEREBY AGREE TO THE TERMS AND
CONDITIONS OF THIS AGREEMENT. IF YOU DO NOT AGREE WITH THE TERMS AND CONDITIONS OF
THIS AGREEMENT, THEN YOU SHOULD NOT USE, REPRODUCE, MODIFY THE KONTERA PLUG-IN IN
ANY WAY.
1. Definitions.
1.1. “Kontera Plug-In” means the plug-in that facilitates Publisher’s implementation of tags on the Publisher
Webpages.
1.2. “Publisher Web Pages” means all of the web pages in the domain(s) owned or controlled by Publisher.
2. Kontera Plug-In License.
2.1. Grant. Subject to the terms and conditions of this Agreement, Kontera grants to Publisher a nonsublicensable,
non-exclusive, non-transferable license to use, reproduce and modify the Kontera Plug-In but
solely on the Publisher Web Pages.
2.2. Restrictions and Ownership. Publisher shall not: (i) use the Kontera Plug-In for the purposes of developing a
product that will be owned by a third party or that would compete with Kontera’s products or services;
(ii) sublicense, rent, lend, lease, permit third party access to, or use of, the Kontera Plug-In; (iii) copy,
distribute, reproduce, sell, use or allow access to the Kontera Plug-In, except as explicitly permitted under this
Agreement; or (iv) remove, obscure, or alter Kontera’s copyright notice, trademarks, or other proprietary rights
notices affixed to or contained within the Kontera Plug-In. As between the parties, except for the explicit
license granted herein, Kontera, or its licensors, shall retain all right, title and interest in and to the Kontera
Plug-In. This is license, not a sale, so title to the Kontera Plug-In shall not pass to Publisher under any
circumstances. Kontera does not grant to Publisher any license, express or implied, under the intellectual
property of Kontera or its licensors except as expressly stated in this Agreement.
3. Confidentiality. “Confidential Information” means any information disclosed by Kontera to Publisher, either
directly or indirectly in writing, orally or by inspection of tangible objects which is either (i) designated or marked
as “Confidential” at the time of disclosure, or (ii) disclosed under circumstances reasonably indicating that such
information is confidential. Without limiting the foregoing, the Kontera Plug-In, all information relating to the
Kontera Plug-In, and the terms and conditions of this Agreement shall be deemed the Confidential Information of
Kontera. During the term of this Agreement and for three (3) years following the expiration or termination of this
Agreement, (A) Publisher agrees that it shall not use any Confidential Information other than as expressly permitted
under the terms of this Agreement or as expressly authorized in writing by Kontera, (B) Publisher shall use the same
degree of care to protect Confidential Information as it uses to protect its own most highly confidential information,
but in no circumstances less than reasonable care, and (C) Publisher shall not disclose Confidential Information to
any person or entity other than its officers, employees and consultants who need access to such Confidential
Information in order to effect the intent of this Agreement and who have entered into written confidentiality
agreements with it consistent with this Section 3.
4. Term and Termination. Unless earlier terminated as set forth herein, this Agreement is effective from the Effective
Date through the first anniversary of the Effective Date. After such time, this Agreement will automatically renew
for successive twelve (12) month terms unless either party notifies the other party that such party will not renew the
Agreement within thirty (30) days of the end of the then-current term. Either party may terminate this Agreement for
any reason or for no reason at any time upon thirty (30) days notice to the other party. The following sections will
survive any expiration or termination of this Agreement: 2.2, 3, 4, 5, 6 and 7.
5. Disclaimer of Warranties. THE KONTERA PLUG IN IS PROVIDED “AS IS” AND WITHOUT
REPRESENTATIONS, WARRANTIES OR CONDITIONS, WHETHER EXPRESS, IMPLIED, STATUTORY
OR OUT OF A COURSE OF DEALING OR USAGE OF TRADE, INCLUDING BUT NOT LIMITED TO
IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
-2-
FITNESS FOR ANY PARTICULAR PURPOSE OR USE, NONINFRINGEMENT, QUALITY,
PRODUCTIVENESS OR CAPACITY, AND ALL SUCH WARRANTIES ARE HEREBY DISCLAIMED.
KONTERA, ITS SUPPLIERS, LICENSORS, AND PARTNERS DO NOT WARRANT THAT THE FUNCTIONS
OF THE KONTERA PLUG-IN WILL BE CORRECT, UNINTERRUPTED OR ERROR-FREE, THAT DEFECTS
WILL BE CORRECTED, OR THAT THE KONTERA PLUG-IN IS FREE OF VIRUSES OR OTHER HARMFUL
COMPONENTS. KONTERA MAKES NO GUARANTEE REGARDING THE NUMBER, QUALITY, OR
CONTENT OF ANY ADVERTISEMENTS OR THE TIMING OF DELIVERY OF SUCH ADVERTISEMENTS
FOLLOWING USE OF THE KONTERA PLUG-IN. THE FOREGOING DISCLAIMER OF WARRANTY IS A
FUNDAMENTAL PART OF THE BASIS OF KONTERA’S BARGAIN HEREUNDER, AND THAT KONTERA
WOULD NOT ENTER INTO THIS AGREEMENT ABSENT SUCH DISCLAIMER.
6. Limitation of Liability. KONTERA SHALL NOT BE LIABLE FOR ANY CONSEQUENTIAL, INCIDENTAL,
INDIRECT, PUNITIVE, SPECIAL OR OTHER SIMILAR DAMAGES NOR FOR ANY LOSS OF PROFITS,
LOSS OF REVENUES, LOSS OF SAVINGS, LOSS OF CLIENTELE, LOSS OF USE OR LOSS OR
CORRUPTION OF DATA, WHETHER UNDER TORT, CONTRACT OR OTHER THEORIES OF RECOVERY,
EVEN IF SUCH PARTY WAS OR SHOULD HAVE BEEN AWARE OR WAS ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES, AND IN NO EVENT WILL EITHER PARTY’S LIABILITY ARISING
OUT OF THIS AGREEMENT FROM ANY CAUSE OF ACTION WHATSOEVER WILL EXCEED THE
AGGREGATE AMOUNTS ACTUALLY PAID UNDER THIS AGREEMENT BY KONTERA TO PUBLISHER
DURING THE THREE (3) MONTHS PRIOR TO THE DATE THE CAUSE OF ACTION AROSE.
7. Miscellaneous. This Agreement is the entire agreement between the parties on the subject matter hereof. No
amendment or modification hereof will be valid or binding upon the parties unless made in writing and signed by the
duly authorized representatives of both parties. The relationship of the parties hereunder is that of independent
contractors, and this Agreement will not be construed to imply that either party is the agent, employee, or joint
venturer of the other. In the event that any provision of this Agreement is held to be unenforceable, the Agreement
will continue in full force and effect without such provision and will be interpreted to reflect the original intent of
the parties. This Agreement will be governed by the law of the State of California, without regard to its conflict of
laws principles. The parties consent to the personal and exclusive jurisdiction of courts located in San Francisco,
California. Neither party may assign any of its rights or obligations under this Agreement without the prior written
consent of the other, except that either party may assign any of its rights and obligations under this Agreement
without consent of the other party in connection with any merger, consolidation, reorganization, sale of all or
substantially all of its assets related to this Agreement or other similar transaction. This Agreement shall inure to the
benefit of and shall be binding on each party’s permitted assignees, transferees and successors. Wavier by either
party of a breach of any provision of this Agreement or the failure by either party to exercise any right hereunder
will not operate or be construed to be a waiver of any subsequent breach of any right or as a waiver of any other
right. Except for the payment of fees hereunder, nonperformance of either party will be excused to the extent that
performance is rendered impossible by strike, fire, flood, earthquake, governmental acts or orders or restrictions, or
any other reason when failure to perform is beyond the reasonable control of the nonperforming party.

*/
define('KONTERA_ADSON_FULLPAGE','1');
define('KONTERA_ADSON_CONTENT_ONLY','2');
define('KONTERA_ADSON_COMMENT_ONLY','3');
//////start code///////
/**
 * Attempts to understand what page/category/post we view and determine
 * if the kontera javascript should or should not be injected here
 * @return boolean true if javascript should be injected
 */


function kontera_should_show() {
	// get disabled categories from user's settings
	$disabled_categories = get_option('kontera_disabled_categories');

	// loop through item's categories, if we are on a disabled category return false
	$categories = get_the_category();
	foreach ($categories as $cat) {
                $cat->cat_name = preg_replace('/&#038;/','&',$cat->cat_name);
                $cat->cat_name = preg_replace('/&amp;/','&',$cat->cat_name);
		if(!is_array($disabled_categories)){
			if($cat->cat_name == $disabled_categories){
				return false;
			}
		}else if (in_array($cat->cat_name, $disabled_categories)){
			return FALSE;
		}
	}
	return TRUE;
}

function kontera_is_ad_enabled() {
	return (get_option('toggle_kontera_tag') == "enable");
}

function kontera_is_page_enabled() {
	// get disabled pages from user's settings
	$disabled_pages = explode(',', get_option('kontera_disabled_pages'));

	// loop through item's pages, if we are on a disabled pages return false
	global $post;
	$current_page = $post->ID;
 	if (isset ($current_page) == false) {
 		return true;
 	}
	foreach ($disabled_pages as $page) {
		if ($current_page == intval($page)) {
			return false;
		}
	}
	return TRUE;
}

/**
 * This function echoes the kontera javascript for the configured user
 */
function kontera_echo_javascript() {
	$toggle_kontera_tag = kontera_is_ad_enabled();
	if(!$toggle_kontera_tag) {
		return ;
	}

	global $kontera_ads_disabled_on_page;
	global $kontera_current_page_is_home;

	if($kontera_current_page_is_home || !$kontera_ads_disabled_on_page) {
	    // get the user's settings
	    $publisher_id = get_option('kontera_publisher_id');
	    $ad_link_color = get_option('color_value','#0000ff');

?>	<!-- Kontera ContentLink -->
    <script type="text/javascript">
	var dc_UnitID = 14;
	var dc_PublisherID = <?php echo $publisher_id ?>;
	var dc_AdLinkColor = '<?php echo $ad_link_color ?>';
	var dc_isBoldActive = 'no';
	var dc_open_new_win = 'yes';
	var dc_adprod='ADL';
    </script>
    <script type="text/javascript" SRC="http://kona.kontera.com/javascript/lib/KonaLibInline.js"></script>
    <!-- Kontera ContentLink -->
    <?php
	}
}

/**
 * Adds the Kontera Settings menu to the Options page
 */
function kontera_menu() {
	add_options_page('Kontera Settings', 'Kontera Settings', 8, __FILE__, 'kontera_options_menu');
}

/**
 * Output the options menu page, including the form that updates the user's settings
 */
function kontera_options_menu() {
?>
    <div class="wrap">
    <h2> Kontera Settings </h2>

	<form method="post" action="">
	<p class="submit">
	<input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" />
	</p>
	<?php

	echo '<table border="0" cellspacing="5">';
	// define plugin parameters and descriptions
	$parameters = array (
		'kontera_publisher_id' => 'Kontera Publisher ID',
		'kontera_disabled_pages' => 'Block ContentLinks&reg; from pages<br /><font size="1" color="gray"> Be sure to separate page ID numbers  with commas (e.g 23, 25, 1)</font>'
	);

	$isValidPublisherId = (preg_match('/^\d+$/', $_POST['kontera_publisher_id']));
	$isValidBlockDays = (preg_match('/^\d*$/', $_POST['kontera_disable_new_days']));
	if ($_POST['action'] == 'update' && $isValidPublisherId && $isValidBlockDays) {

		$kontera_adson = $_POST['kontera_adson'];

		update_option('kontera_adson', $kontera_adson);
		update_option('kontera_publisher_id', $_POST['kontera_publisher_id']);
		update_option('kontera_disabled_pages', $_POST['kontera_disabled_pages']);
		$toggle_tag = $_POST['toggle_kontera_tag'];
		$toggle_tag = ($toggle_tag == 'on') ? "disable" : "enable";
		update_option('toggle_kontera_tag', $toggle_tag);
		update_option('kontera_disable_new_days', $_POST['kontera_disable_new_days']);
		update_option('color_value', $_POST['color_value']);
		$kontera_disabled_categories = $_POST['kontera_disabled_categories'];
		// To filter 'None'
		foreach($kontera_disabled_categories as $key => $category) {
			if($category == 'None'){
				unset($kontera_disabled_categories[$key]);
			}
		}
		update_option('kontera_disabled_categories', $kontera_disabled_categories);
	}
	if ($_POST['action'] != 'update') {
		$isValidPublisherId = $isValidBlockDays = 1;
	}

	echo "<tr><td> $parameters[kontera_publisher_id] </td> <td> <input type='text' name='kontera_publisher_id' value='" . get_option('kontera_publisher_id') . "' /> </td>", (!$isValidPublisherId) ? "<td style=' color:red'>Please enter a valid publisher id</td>" : "", "</tr>";
	echo "<tr><td> $parameters[kontera_disabled_pages] </td> <td> <textarea name='kontera_disabled_pages' >" . get_option('kontera_disabled_pages') . "</textarea> </td></tr>";
?>

	<script src="<?php echo get_option('siteurl'); ?>/wp-content/plugins/kontera/palette.js" type="text/javascript"></script>
	<link href="<?php echo get_option('siteurl'); ?>/wp-content/plugins/kontera/palette.css" media="screen" rel="stylesheet" type="text/css" />
	<tr>
		<td>
			<label for="s_color">Select your ContentLinks' color</label>
		</td>
		<td>
			<div style='width:30' id="color_preview_wrapper">
				<img id="pal_img" src="<?php echo get_option('siteurl'); ?>/wp-content/plugins/kontera/pal.gif" width="16" height="16" alt="Open Palette" onclick="openPalette('color_preview')"/>
			</div>
			<div  id="color_preview" onclick="openPalette('color_preview')" style="color:<?php echo get_option('color_value','#0000ff') ?>;">ContentLinks</div>
		</td>
		<td>
			<input  type="hidden" id="color_value" name="color_value" onclick="openPalette('color_preview')" type="text" value="<?php echo get_option('color_value',"#0000ff") ?>" />
        </td>
	</tr>
    <script type="text/javascript">
	</script>
<?php


	echo "<tr><td> Block ads from new posts for  <BR> <font size='1' color='gray'> Do not show ads on new posts for X days </font> </td> <td> <input type='text' name='kontera_disable_new_days' value='" . get_option('kontera_disable_new_days', 0) . "' /> days </td>", (!$isValidBlockDays) ? "<td style=' color:red'>Please enter a valid number of days</td>" : "", "</tr>";
?>


	<tr >
		<td> Block ContentLinks from categories<BR><font size="1" color="gray"> To select more than one category hold &lt;Ctrl&gt; and click on<br/> the name of each category you'd like to block</font>
		</td> 
		<td>
 			<select style="height:<?php echo min(160,20*(sizeof(get_categories())+1)); ?>px;" name="kontera_disabled_categories[]" multiple="true" size="10">
			<?php 
				// To add None to the categories list
				$disabled_categories_array = get_option('kontera_disabled_categories');
				$selected = empty($disabled_categories_array) ? "selected='selected'" : ""; 
			?>
				<option value="None" <?php echo $selected; ?> >None</option>
				<?php
					$categories = get_categories();
					foreach (array_values($categories) as $cat) {
						$option = '<option value="' . $cat->cat_name . '" ';
						$disabled_categories_array = get_option('kontera_disabled_categories');
						if (!$disabled_categories_array) {
							$disabled_categories_array = array ();
						}
								$cat->cat_name = preg_replace('/&#038;/','&',$cat->cat_name);
								$cat->cat_name = preg_replace('/&amp;/','&',$cat->cat_name);
						$option .= (in_array($cat->cat_name, array_values($disabled_categories_array))) ? "selected='selected'" : "";
						$option .= " >";
						$option .= $cat->cat_name;
						$option .= '</option>';
						echo $option;
					}
				?>
			</select>
		</td>
	</tr>
	
	<script>
	 function isUnsignedInteger(s) {
 	        return (s.toString().search(/^[0-9]+$/) == 0);
 	}
	</script>
	
	<?php
		$kontera_adson = get_option('kontera_adson');
		$toggle_tag = get_option('toggle_kontera_tag');
		$disabled_condition = ($toggle_tag == 'disable') ? " disabled = 'disabled' " : " ";
	?>
	<script> 
 		function disableAllCheckBox() 
 		{
			var is_checked = document.getElementById('disable_kontera_ads').checked;
			document.getElementById('kontera_adson_full').disabled = is_checked;
			document.getElementById('kontera_adson_content').disabled = is_checked;
			document.getElementById('kontera_adson_comment').disabled = is_checked;
 		}
	</script>

	<tr height=30><td><input type='radio' id='kontera_adson_full' name='kontera_adson' value="1" <?php echo (($kontera_adson == "1") ? 'checked' : '') . $disabled_condition; ?>    />Enable ContentLinks Ads on full page </td></tr>
	<tr height=30><td>&nbsp;&nbsp;&nbsp;<input type='radio' id='kontera_adson_content' name='kontera_adson' value="2" <?php echo (($kontera_adson == "2") ? 'checked' : '') . $disabled_condition; ?>     />Enable ContentLinks Ads only on posts </td></tr>
	<tr height=30><td>&nbsp;&nbsp;&nbsp;<input type='radio' id='kontera_adson_comment' name='kontera_adson' value="3" <?php echo (($kontera_adson == "3") ? 'checked' : '') . $disabled_condition;  ?>    />Enable ContentLinks Ads only on comments</td></tr>
	<tr height=20><td></td></tr>
	<tr height="30"><td><input id="disable_kontera_ads" type="checkbox" name="toggle_kontera_tag" <?php echo (($toggle_tag == "disable") ? 'checked="checked"' : '') ;  ?>  onclick="disableAllCheckBox();"/> Disable Kontera Ads</td></tr>
	<?php 
		echo '</table>';
		// this is needed for some wordpress thing to show which parameters are we updating
		$page_options = implode(',', array_keys($parameters));
	?>

	<!-- palette hidden div -->
        <div id="palette">
        <h2 style="padding:0pt 20px 7px 0pt;">Choose link color</h2>
	<table id="swatches" cellpadding="0" cellspacing="0">
        <script type="text/javascript">
                createRows('5','14');
        </script>
	</table>
	<img src="<?php echo get_option('siteurl'); ?>/wp-content/plugins/kontera/pal_cancel.gif" border="0" width="48" height="15" style="float:left; padding: 5px 0 0 8px;"    onclick="pal_reset()" />
	<img src="<?php echo get_option('siteurl'); ?>/wp-content/plugins/kontera/pal_ok.gif" border="0" width="48" height="15" style="float:right;  padding: 5px 8px 0 0;" onclick="setVal()"/>

</div>

	
	<input type="hidden" name="page_options" value="<?php echo $page_options ?>" />
	<input type="hidden" name="action" value="update" />
	<BR>	
	<p class="submit">
	<input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" />
	</p>
	</form>	
    </div>
    <?php

}

function kontera_is_young_post() {
	global $post;
	$disable_new_days = get_option('kontera_disable_new_days');
	$new_post_date = time() - $disable_new_days * 86400;
	return mysql2date('U', $post->post_date) > $new_post_date;
}

function kontera_add_zone_tag_to_content($text) {
	// If home, display content of page alone within KonaBody tag.
	// If a post should be blocked from showing ads don't include it in KonaBody
	global $kontera_current_page_is_home;
	global $kontera_ads_disabled_on_page;
	$kontera_current_page_is_home = is_home();
	$kontera_ads_disabled_on_page = (kontera_is_young_post() || !kontera_should_show() || !kontera_is_page_enabled());

	if($kontera_current_page_is_home){
		//To block ads if post date less X days or disabled post or disabled categories in home page
		if($kontera_ads_disabled_on_page){
			return '<div class="KonaFilter">' . $text . '</div>';
		}
		else {
			return $text;
		}
	}
	else {

	  // If Run Ads on full page don't include KonaBody tags
	  $kontera_adson = get_option('kontera_adson');
	  if($kontera_adson == KONTERA_ADSON_FULLPAGE) {
		return $text;
	  }

	  if($kontera_adson == KONTERA_ADSON_COMMENT_ONLY) {
		// Add an empty KonaBody tag to the end of content, so that Ads will still have proper behavior if there are no comments
		return '<div class="KonaFilter">' . $text . '</div>';
	  } 
	} 

	return '<div class="KonaBody">' . $text . '</div>';
}

// Add Kontera tags to page only if ads are enabled
if (kontera_is_ad_enabled()) { 
    add_filter('the_content', 'kontera_add_zone_tag_to_content');
}

// Show checkbox in admin panel write page/post
function kontera_block_content_link() {
    global $post;
    $post_id = $post->ID;
?>
	<div class="postbox">
		<h3 class="hndle"><span>Kontera ContentLinks</span></h3>
			<div class="inside">
				<?php
				$checked = '';
				if(kontera_is_page_enabled()) {
					$checked = 'checked="checked"';
				}
				echo '<input type="checkbox" name="display_content_link" '.$checked.'/> Display ContenLink Ads on this post';
				?>
			</div>
	</div>

<?php
}

// On write of post/page
function kontera_write_post_or_page() {
    if($_POST) {
        $post_id = $_POST['post_ID'];
	    $display_content_link = $_POST['display_content_link'];
		$disabled_pages = get_option('kontera_disabled_pages');
		$disabled_pages_array = explode(',', $disabled_pages);
	    if($display_content_link != 'on') {
			if(!empty($disabled_pages_array) && in_array($post_id, $disabled_pages_array)) {
				return;
			}
		    if($post_id > 0) {
		        $disabled_pages = empty($disabled_pages) ? $post_id : $disabled_pages.", ".$post_id;
		        update_option('kontera_disabled_pages', $disabled_pages);
		    }
	    }
        else {
            if(!empty($disabled_pages)) {
                foreach($disabled_pages_array as $key => $page_id) {
                    if(intval($page_id) == $post_id) {
                        unset($disabled_pages_array[$key]);
                    }
                }
                $disabled_pages = implode(", ", $disabled_pages_array);
                update_option('kontera_disabled_pages', $disabled_pages);
            }
        }
    }
}

add_action('submitpost_box', 'kontera_block_content_link');
add_action('submitpage_box', 'kontera_block_content_link');
add_action('edit_post', 'kontera_write_post_or_page');
add_action('edit_page', 'kontera_write_post_or_page');

// default settings and parameters
add_option('kontera_adson', KONTERA_ADSON_FULLPAGE);
add_option('kontera_publisher_id', '1');
add_option('kontera_adlinkcolor', '0000ff');
add_option('kontera_disabled_categories', '');
add_option('kontera_disabled_pages', '');

add_action('admin_menu', 'kontera_menu');
add_action('wp_footer', 'kontera_echo_javascript');
?>
